package com.pizza.mainClassPackage;

import java.util.Scanner;

import com.pizza.entity.User;
import com.pizza.service.UserAuthentication;

/**
 * 
 * @author 
 * Main class where the program starts
 * Program execution starts from this class
 *
 */
public class PizzaMainLogin {
	/**
	 * Scanner object from Inputs and outputs
	 */
	private static Scanner sc=new Scanner(System.in);
	/**
	 * User Authentication object for performing all user login related questions
	 */
	private static UserAuthentication authentication=new UserAuthentication();
	public static void main(String args[])
	{
		/**
		 * Infinite loop calling two functions
		 */
		while(true)
		{
			int choice=printMenu();
			performOperation(choice);
		}
	}
/**
 * 
 * @param choice int paramter passed
 * take a parameter and perform the functionality accordingly
 */
	private static void performOperation(int choice) {
		switch(choice)
		{
		case 0:
			exit();
			break;
		case 1:
			login();
			break;
		case 2:
			register();
			break;
		default:
			System.out.println("Invalid Choice. Please Try Again");
		}

	}

	/**
	 * register functionality
	 * Take the user details and register the user
	 * Open the user menu for the user
	 */
	private static void register() {
		System.out.println("Enter your details");
		System.out.println("ForeName :");
		String fName=sc.nextLine();
		System.out.println("SurName :");
		String sName=sc.nextLine();
		System.out.println("Email :");
		String email=sc.nextLine();
		System.out.println("Password :");
		String pwd=sc.nextLine();
		User user=new User(fName,sName,email,pwd);
		authentication.registerUser(user);
		System.out.println("Cutomer Registered Successfully");
		PizzaMainMenu menu=new PizzaMainMenu(user);
		menu.startModule();
		
	}

	/**
	 * take user email and pwd and login the user
	 * to pizza main menu
	 */
	private static void login() {
		System.out.println("Enter your details :");
		System.out.print("EMail : ");
		String email=sc.nextLine();
		System.out.print("Password : ");
		String pwd=sc.nextLine();
		User user=authentication.authenticate(email,pwd);
		if(user!=null)
		{
			PizzaMainMenu menu=new PizzaMainMenu(user);
			menu.startModule();
		}
		else
		{
			System.out.println("Wrong Username/Password Combination");
		}

	}

	/**
	 * terminates the program if user confirms to do so
	 */
	private static void exit() {
		System.out.print("Are you sure you want to Exit.(y/n) : ");
		char ch=sc.nextLine().charAt(0);
		switch(ch)
		{
		case 'y':
			System.out.println("You chose to Exit. Exiting...");
			System.exit(0);
		}
		System.out.println("Not Exiting.");


	}

	/**
	 * print the login menu for the user and take a int choice
	 * @return choice entered by the user
	 */
	private static int printMenu() {
		System.out.println("Welcome to Pizza Application ");
		System.out.println("1. Login");
		System.out.println("2. Register");
		System.out.println("0. Exit");
		System.out.print("Please Enter Your Choice : ");
		try
		{
			return	Integer.parseInt(sc.nextLine());
		}
		catch(Exception e)
		{
			System.out.println("Please enter an Integer Input");
			return printMenu();
		}
	}
}
