package com.pizza.mainClassPackage;

import java.util.Scanner;

import com.pizza.entity.User;
import com.pizza.service.MainFunction;

/**
 * 
 * @author 
 * Pizza main menu class to perform the main activities for Customer
 *
 */
public class PizzaMainMenu {
	/**
	 * Scanner object for taking inputs 
	 */
	private Scanner sc=new Scanner(System.in);
	/**
	 * current logged in user
	 */
	private User user;
	/**
	 * Main Function class object to perform the functionality
	 */
	private MainFunction function;
	
	/**
	 * 
	 * @param user logged user
	 */
	public PizzaMainMenu(User user)
	{
		this.user=user;
		function=new MainFunction(user);
	}
	
	/**
	 * Infinite loop to get user choice till user choose to logout
	 */
	public void startModule() {
		while(true)
		{
			int choice=printMenu();
			
			performOperation(choice);
			if(choice==0)
				return;
		}
		
	}
	
	/**
	 * 
	 * @param choice choice entered by the user
	 * Take input and perform accordingly
	 */
	private void performOperation(int choice) {
		switch(choice)
		{
			case 0:
				System.out.println("Logging Out");
				return;
			case 1:
				function.orderPizza();
				break;
			case 2:
				function.cancelOrder();
				break;
			case 3:
				function.viewOrders();
				break;
			case 4:
				function.editRegistration();
				break;
		}
		
	}
	
	/**
	 * print the Choices Menu
	 * @return choice entered by the user 
	 */
	private int printMenu() {
		System.out.println("Welcome Customer "+user.getForeName());
		System.out.println("1. Order a Pizza");
		System.out.println("2. Cancel an Order");
		System.out.println("3. View Orders");
		System.out.println("4. Edit Registration");
		System.out.println("0. Exit");
		System.out.print("Please Enter Your Choice : ");
		try
		{
			return	Integer.parseInt(sc.nextLine());
		}
		catch(Exception e)
		{
			System.out.println("Please enter an Integer Input");
			return printMenu();
		}
	}

}
